-- GoldenAgeUA
-- Author: Kenneth
-- DateCreated: 2/26/2016 2:54:50 PM
--------------------------------------------------------------
local eGeorgiaCiv = GameInfoTypes["CIVILIZATION_GEORGIA"]
local iGlobalGATurns = 0
local greatPeopleTb = {}
greatPeopleTb[0] = GameInfo.Units.UNIT_ARTIST.Type
greatPeopleTb[1] = GameInfo.Units.UNIT_WRITER.Type
greatPeopleTb[2] = GameInfo.Units.UNIT_MUSICIAN.Type
greatPeopleTb[3] = GameInfo.Units.UNIT_SCIENTIST.Type
greatPeopleTb[4] = GameInfo.Units.UNIT_MERCHANT.Type
greatPeopleTb[5] = GameInfo.Units.UNIT_ENGINEER.Type
greatPeopleTb[6] = GameInfo.Units.UNIT_GREAT_GENERAL.Type



print("[GEORGIA] Loaded.")

function tablerandom(tbl)
	local keys = {}
	for k in pairs(tbl) do
		table.insert(keys, k)
	end
	local randIndex = math.random(#keys)
	local randKey = keys[randIndex]
	return tbl[randKey]
end

function GeorgiaGA(iPlayer)
	local pPlayer = Players[iPlayer]
	if pPlayer:GetCivilizationType() == eGeorgiaCiv then
		print("[GeorgiaGA] Correct Civ.")
		local iCurrGA = pPlayer:GetGoldenAgeTurns()
		if pPlayer:IsGoldenAge() then
			print("[GeorgiaGA] Player is in a Golden Age.")
			if iCurrGA > iGlobalGATurns then
				print("[GeorgiaGA] Either new Golden Age or an extended one.")
				local pCapital = pPlayer:GetCapitalCity()
				local pPlot = pCapital:Plot()
				local eUnitType = tablerandom(greatPeopleTb)
				local pNewUnit = pPlayer:InitUnit(GameInfoTypes[eUnitType], pPlot:GetX(), pPlot:GetY())
				if not (pPlayer:IsHuman()) then
					pNewUnit:JumpToNearestValidPlot()
				end
			end
		end
		iGlobalGATurns = iCurrGA
		print("[GeorgiaGA] Global variable set to current number of turns.")
	end
end




GameEvents.PlayerDoTurn.Add(GeorgiaGA)